Attribute VB_Name = "AssocOneImageIcon"
Option Explicit


Declare Function RegCreateKeyEx& Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey&, ByVal lpSubKey$, ByVal Reserved&, ByVal lpClass$, ByVal dwOptions&, ByVal samDesired&, ByVal SecAtts&, phkResult&, lpdwDisp&)
Declare Function RegDeleteValue& Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey&, ByVal lpValueName$)
Declare Function RegOpenKeyEx& Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey&, ByVal lpSubKey$, ByVal ulOptions&, ByVal samDesired&, phkResult&)
Declare Function RegSetValueEx& Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey&, ByVal lpValueName$, ByVal Reserved&, ByVal dwType&, ByVal lpData$, ByVal cbData&)
Public Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" (ByVal hKey As Long, ByVal lpSubKey As String) As Long

'========Read registry key values
Public Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Public Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As String, lpcbData As Long) As Long
'Reg DataType Constants ...............................
Public Const REG_SZ = 1 ' Unicode null terminated string
Public phkResult As Long
Public lpSubKey As String
Public lpData As String
Public lpcbData As Long
Public RC As Long

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003

Public Const KEY_ALL_ACCESS = (&H1F0000 Or &H1 Or &H2 Or &H4 Or &H8 Or &H10 Or &H20) And (Not &H100000)
Public Sub AssociateFileExtension(PathToExecute As String, subKeyName As String)
'=======Start Code works for WinXP, but not Win98
'    Dim RegData$, Rv&
''====HKEY_CLASSES_ROOT entry
'    'If the key already exists, RegCreateKeyEx opens the existing key.
'    'hKey is phkResult in Declare RegCreateKeyEx
'    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, subKeyName, 0, vbNullString, 0, KEY_ALL_ACCESS, 0, phkResult, 0)
'    If Rv = 0 Then 'Success
'        '0 is reserved, "Windows Icon" is value of string, 12 is number of characters in "Windows Icon"
'       RegSetValueEx phkResult, vbNullString, 0, REG_SZ, "Windows Icon", 12 'vbNullString is (Default) entry; 12 is number of characters in "Windows Icon"
'       RegCloseKey phkResult
'    End If
'
'    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, subKeyName & "\DefaultIcon", 0, vbNullString, 0, KEY_ALL_ACCESS, 0, phkResult, 0)
'    If Rv = 0 Then
'       RegSetValueEx phkResult, vbNullString, 0, REG_SZ, "%1", 2 '2 is number of characters in %1
'       RegCloseKey phkResult
'    End If
'
'    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, subKeyName & "\Shell\Open\Command", 0, vbNullString, 0, KEY_ALL_ACCESS, 0, phkResult, 0)
'    If Rv = 0 Then
'       If Right(App.Path, 1) = "\" Then
'          RegData = App.Path & App.EXEName & ".exe"
'       Else
'          RegData = App.Path & "\" & App.EXEName & ".exe"
'       End If
'       RegData = RegData & " /open %1"
'       RegSetValueEx phkResult, vbNullString, 0, REG_SZ, RegData, Len(RegData)
'       RegCloseKey phkResult
'    End If
''====HKEY_LOCAL_MACHINE entry ???? putting it in HKEY_CLASSES_ROOT above puts it in HKEY_LOCAL_MACHINE also
'
''====HKEY_CURRENT_USER entry Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.ico
'
'    Rv = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.ico", 0, vbNullString, 0, KEY_ALL_ACCESS, 0, phkResult, 0)
'    If Rv = 0 Then
'       RegSetValueEx phkResult, "ProgID", 0, REG_SZ, subKeyName, Len(subKeyName)
'       RegCloseKey phkResult
'    End If
''====HKEY_USERS entry S-1-5-21-73586283-492894223-854245398-1003\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.ico
'    Rv = RegCreateKeyEx(HKEY_USERS, "S-1-5-21-73586283-492894223-854245398-1003\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.ico", 0, vbNullString, 0, KEY_ALL_ACCESS, 0, phkResult, 0)
'    If Rv = 0 Then
'       RegSetValueEx phkResult, "ProgID", 0, REG_SZ, subKeyName, Len(subKeyName)
'       RegCloseKey phkResult
'    End If
'=======End Code works for WinXP, but not Win98
'======Start Code for WinXP and Win98
    Dim RegData$, Rv&, s&
    'WinXP has 'PerceivedType' that must be renamed
    lpSubKey = ".ico"
    Rv = RegOpenKey(HKEY_CLASSES_ROOT, lpSubKey, phkResult)
    If Rv = 0 Then 'Success
        lpData = Space(255)
        lpcbData = Len(lpData)
        Rv = RegQueryValueEx(phkResult, "PerceivedType", 0&, REG_SZ, lpData, lpcbData)
        If Rv = 0 Then
            Rv = RegDeleteValue(phkResult, "PerceivedType")
            '0 is reserved, "image" is value of string, 5 is number of characters in "image"
            RegSetValueEx phkResult, "TMP-PerceivedType", 0, REG_SZ, "image", 5 'vbNullString is (Default) entry; 12 is number of characters in "Windows Icon"
        End If
       RegCloseKey phkResult
    End If
'====HKEY_CLASSES_ROOT entry
    'If the key already exists, RegCreateKeyEx opens the existing key.
    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, subKeyName, 0, vbNullString, 0, KEY_ALL_ACCESS, 0, phkResult, 0)
    If Rv = 0 Then 'Success
        '0 is reserved, "Windows Icon" is value of string, 12 is number of characters in "Windows Icon"
       RegSetValueEx phkResult, vbNullString, 0, REG_SZ, "Windows Icon", 12 'vbNullString is (Default) entry; 12 is number of characters in "Windows Icon"
       RegCloseKey phkResult
    End If

    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, subKeyName & "\DefaultIcon", 0, vbNullString, 0, KEY_ALL_ACCESS, 0, phkResult, 0)
    If Rv = 0 Then
       RegSetValueEx phkResult, vbNullString, 0, REG_SZ, "%1", 2 '2 is number of characters in %1
       RegCloseKey phkResult
    End If

    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, subKeyName & "\Shell\Open\Command", 0, vbNullString, 0, KEY_ALL_ACCESS, 0, phkResult, 0)
    If Rv = 0 Then
       If Right(App.Path, 1) = "\" Then
          RegData = App.Path & App.EXEName & ".exe"
       Else
          RegData = App.Path & "\" & App.EXEName & ".exe"
       End If
       RegData = RegData & " /open %1"
       RegSetValueEx phkResult, vbNullString, 0, REG_SZ, RegData, Len(RegData)
       RegCloseKey phkResult
    End If
'====HKEY_LOCAL_MACHINE entry ???? putting it in HKEY_CLASSES_ROOT above puts it in HKEY_LOCAL_MACHINE also

'======End Code for WinXP and Win98
End Sub
Public Sub UnAssociateFileExtension(subKeyName As String)
    '=======Start Code works for WinXP, but not Win98
'        Dim Rv&
'      'This deletes the default icon
'          Rv = RegDeleteKey(HKEY_CLASSES_ROOT, subKeyName & "\DefaultIcon")
'      'This deletes the command subkey for "subKeyName".
'          Rv = RegDeleteKey(HKEY_CLASSES_ROOT, subKeyName & "\shell\open\command")
'      'This deletes open subkey for "subKeyName".
'          Rv = RegDeleteKey(HKEY_CLASSES_ROOT, subKeyName & "\shell\open")
'      'This deletes shell subkey for "subKeyName".
'          Rv = RegDeleteKey(HKEY_CLASSES_ROOT, subKeyName & "\shell")
'      'This deletes "subKeyName".
'          Rv = RegDeleteKey(HKEY_CLASSES_ROOT, subKeyName)
'     '=============
'
'    Rv = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.ico", 0, vbNullString, 0, KEY_ALL_ACCESS, 0, phkResult, 0)
'    If Rv = 0 Then
'       RegDeleteValue& phkResult, "ProgID"
'       RegCloseKey phkResult
'    End If
'
'    Rv = RegCreateKeyEx(HKEY_USERS, "S-1-5-21-73586283-492894223-854245398-1003\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.ico", 0, vbNullString, 0, KEY_ALL_ACCESS, 0, phkResult, 0)
'    If Rv = 0 Then
'       RegDeleteValue& phkResult, "ProgID"
'       RegCloseKey phkResult
'    End If
'
'    '===========
   '=======End Code works for WinXP, but not Win98
   '======Start Code for WinXP and Win98
        Dim Rv&
    'WinXP has 'PerceivedType' that must be restored
    lpSubKey = ".ico"
    Rv = RegOpenKey(HKEY_CLASSES_ROOT, lpSubKey, phkResult)
    If Rv = 0 Then 'Success
        lpData = Space(255)
        lpcbData = Len(lpData)
        Rv = RegQueryValueEx(phkResult, "TMP-PerceivedType", 0&, REG_SZ, lpData, lpcbData)
        If Rv = 0 Then
            Rv = RegDeleteValue(phkResult, "TMP-PerceivedType")
            '0 is reserved, "image" is value of string, 5 is number of characters in "image"
            RegSetValueEx phkResult, "PerceivedType", 0, REG_SZ, "image", 5 'vbNullString is (Default) entry; 12 is number of characters in "Windows Icon"
        End If
       RegCloseKey phkResult
    End If

'      'This deletes the default icon
'          Rv = RegDeleteKey(HKEY_CLASSES_ROOT, subKeyName & "\DefaultIcon")
      'This deletes the command subkey for "subKeyName".
          Rv = RegDeleteKey(HKEY_CLASSES_ROOT, subKeyName & "\shell\open\command")
      'This deletes open subkey for "subKeyName".
          Rv = RegDeleteKey(HKEY_CLASSES_ROOT, subKeyName & "\shell\open")
      'This deletes shell subkey for "subKeyName".
          Rv = RegDeleteKey(HKEY_CLASSES_ROOT, subKeyName & "\shell")
'      'This deletes "subKeyName".
'          Rv = RegDeleteKey(HKEY_CLASSES_ROOT, subKeyName)

   '======End Code for WinXP and Win98
End Sub
